SystemOrganization addCategory: #'Iliad-More-Magritte-Builders'!
SystemOrganization addCategory: #'Iliad-More-Magritte-Decorators'!
SystemOrganization addCategory: #'Iliad-More-Magritte-Widgets'!
SystemOrganization addCategory: #'Iliad-More-Magritte-Report'!
SystemOrganization addCategory: #'Iliad-More-Magritte'!

!ILWidget methodsFor: '*Iliad-More-Magritte' stamp: 'np 4/18/2009 18:55'!
isMagritteContainer
	^false! !

ILWidget subclass: #MAWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Widgets'!

MAWidget subclass: #MADescriptionWidget
	instanceVariableNames: 'description memento parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Widgets'!

MADescriptionWidget subclass: #MAContainerWidget
	instanceVariableNames: 'errors children readonly'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Widgets'!

!MAContainerWidget class methodsFor: 'testing' stamp: 'np 4/13/2009 15:39'!
isAbstract
	^false! !

!MAContainerWidget methodsFor: 'decorating' stamp: 'np 4/13/2009 15:50'!
addForm
	self addForm: #(save cancel)! !

!MAContainerWidget methodsFor: 'decorating' stamp: 'np 8/14/2009 11:11'!
addForm: aCollection
	self decorateWith: (MAFormDecorator buttons: aCollection)! !

!MAContainerWidget methodsFor: 'decorating' stamp: 'np 8/14/2009 11:11'!
addSwitch
	self decorateWith: MASwitchDecorator new.
	self readonly: true! !

!MAContainerWidget methodsFor: 'decorating' stamp: 'np 4/13/2009 15:52'!
addValidatedForm
	self addForm; addValidation! !

!MAContainerWidget methodsFor: 'decorating' stamp: 'np 4/13/2009 15:52'!
addValidatedForm: aCollection
	self addForm: aCollection; addValidation! !

!MAContainerWidget methodsFor: 'decorating' stamp: 'np 4/13/2009 15:52'!
addValidatedSwitch
	self addSwitch; addValidation! !

!MAContainerWidget methodsFor: 'decorating' stamp: 'np 8/14/2009 11:11'!
addValidation
	self decorateWith: MAValidationDecorator new! !

!MAContainerWidget methodsFor: 'private' stamp: 'np 4/13/2009 15:53'!
buildChildren
	^self description
		inject: Dictionary new
		into: [:result :each |
			each isVisible ifTrue: [
				result at: each put: (each widgetClass
					memento: self memento description: each parent: self)].
			result]! !

!MAContainerWidget methodsFor: 'actions' stamp: 'np 4/13/2009 15:54'!
cancel
	self reset; answer: nil! !

!MAContainerWidget methodsFor: 'accessing' stamp: 'np 4/13/2009 15:55'!
childAt: aDescription
	^children at: aDescription ifAbsent: [nil]! !

!MAContainerWidget methodsFor: 'accessing' stamp: 'np 4/13/2009 15:55'!
children
	^children values! !

!MAContainerWidget methodsFor: 'actions' stamp: 'np 4/19/2009 19:17'!
commit
	self 
		withContainersDo: [:each | each memento commit];
		markDirty! !

!MAContainerWidget methodsFor: 'building' stamp: 'np 4/18/2009 18:22'!
contents
	^[:e |
		self description widgetBuilder
		widget: self on: e]! !

!MAContainerWidget methodsFor: 'private' stamp: 'np 4/13/2009 15:53'!
doValidate
	self memento validate.
	self children do: [:each | each doValidate]! !

!MAContainerWidget methodsFor: 'actions' stamp: 'np 4/19/2009 18:42'!
edit
	self readonly: false.
	self markDirty! !

!MAContainerWidget methodsFor: 'accessing' stamp: 'np 4/13/2009 15:55'!
errors
	"Answer a collection of exceptions, the list of standing errors."

	^errors! !

!MAContainerWidget methodsFor: 'initialization' stamp: 'np 4/13/2009 15:40'!
initialize
	super initialize.
	errors := OrderedCollection new! !

!MAContainerWidget methodsFor: 'testing' stamp: 'np 4/18/2009 18:54'!
isMagritteContainer
	^true! !

!MAContainerWidget methodsFor: 'testing' stamp: 'np 4/13/2009 15:40'!
isReadonly
	^super isReadonly or: [self readonly]! !

!MAContainerWidget methodsFor: 'accessing-properties' stamp: 'np 4/13/2009 15:41'!
readonly
	^readonly ifNil: [readonly := false]! !

!MAContainerWidget methodsFor: 'accessing-properties' stamp: 'np 4/13/2009 15:41'!
readonly: aBoolean
	readonly := aBoolean! !

!MAContainerWidget methodsFor: 'actions' stamp: 'np 4/19/2009 18:42'!
reset
	self withContainersDo: [:each | each memento reset].
	self markDirty! !

!MAContainerWidget methodsFor: 'actions' stamp: 'np 4/19/2009 18:24'!
save
	self validate ifFalse: [^self markDirty].
	self commit; answer: self model! !

!MAContainerWidget methodsFor: 'initialization' stamp: 'np 4/13/2009 15:40'!
setChildren: aDictionary
	children := aDictionary! !

!MAContainerWidget methodsFor: 'initialization' stamp: 'np 4/13/2009 15:40'!
setDescription: aDescription
	super setDescription: aDescription.
	self setChildren: self buildChildren! !

!MAContainerWidget methodsFor: 'actions' stamp: 'np 4/13/2009 15:55'!
validate
	errors := OrderedCollection new.
	[self withContainersDo: [:each | each doValidate]]
		on: MAError
		do: [:error |
			errors add: error.
			error isResumable
				ifTrue: [error resume]].
	^errors isEmpty! !

!MAContainerWidget methodsFor: 'private' stamp: 'np 4/13/2009 15:53'!
withContainersDo: aBlock
	"This does a depth first search through all children and evaluates a block for all container widgets that have their own memento."
	
	self withContainersDo: aBlock in: self! !

!MAContainerWidget methodsFor: 'private' stamp: 'np 4/19/2009 17:04'!
withContainersDo: aBlock in: aWidget
	"This does a depth first search through all children and evaluates a block for all container widgets that have their own memento."
	
	aWidget children do: [:each |
		self withContainersDo: aBlock in: each].
	aWidget isMagritteContainer
		ifTrue: [aBlock value: aWidget]! !

!MADescriptionWidget class methodsFor: 'instance creation' stamp: 'np 4/13/2009 15:18'!
memento: aMemento
	^self memento: aMemento description: aMemento description! !

!MADescriptionWidget class methodsFor: 'instance creation' stamp: 'np 4/13/2009 15:18'!
memento: aMemento description: aDescription
	^self memento: aMemento description: aDescription parent: nil! !

!MADescriptionWidget class methodsFor: 'instance creation' stamp: 'np 4/13/2009 15:18'!
memento: aMemento description: aDescription parent: aComponent
	^self new
		setMemento: aMemento;
		setDescription: aDescription;
		setParent: aComponent;
		yourself! !

!MADescriptionWidget methodsFor: 'accessing' stamp: 'np 4/13/2009 15:15'!
description
	^description! !

!MADescriptionWidget methodsFor: 'private' stamp: 'np 4/13/2009 15:16'!
doValidate
	"Enables widgets to raise errors when the model is validated."! !

!MADescriptionWidget methodsFor: 'accessing-dynamic' stamp: 'np 4/5/2010 17:49'!
id
	^self class name asLowercase , self hash greaseString! !

!MADescriptionWidget methodsFor: 'testing' stamp: 'np 4/13/2009 15:15'!
isReadonly
	 ^self description isReadonly
		or: [self isRoot not
		and: [self parent isReadonly]]! !

!MADescriptionWidget methodsFor: 'testing' stamp: 'np 4/13/2009 15:14'!
isRoot
	^self parent isNil! !

!MADescriptionWidget methodsFor: 'accessing' stamp: 'np 4/18/2009 18:59'!
labelId
	^self id, 'label'! !

!MADescriptionWidget methodsFor: 'accessing' stamp: 'np 4/13/2009 15:15'!
memento
	^memento! !

!MADescriptionWidget methodsFor: 'accessing-dynamic' stamp: 'np 4/13/2009 15:16'!
model
	^self memento model! !

!MADescriptionWidget methodsFor: 'accessing' stamp: 'np 4/13/2009 15:15'!
parent
	^parent! !

!MADescriptionWidget methodsFor: 'accessing-dynamic' stamp: 'np 4/13/2009 15:17'!
root
	^ self isRoot
		ifTrue:  [self]
		ifFalse: [self parent root]! !

!MADescriptionWidget methodsFor: 'initialization' stamp: 'np 4/13/2009 15:18'!
setDescription: aDescription
	description := aDescription! !

!MADescriptionWidget methodsFor: 'initialization' stamp: 'np 4/13/2009 15:18'!
setMemento: aMemento
	memento := aMemento! !

!MADescriptionWidget methodsFor: 'initialization' stamp: 'np 4/13/2009 15:18'!
setParent: aComponent
	parent := aComponent! !

MADescriptionWidget subclass: #MAElementWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Widgets'!

!MAElementWidget commentStamp: 'np 4/16/2009 18:00' prior: 0!
I provide a basic display for all subclasses of MAElementDescription (only for readonly descriptions). The object is just displayed as a string. For more complex behaviour, override #viewerElement. !

MAElementWidget subclass: #MACheckboxWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Widgets'!

!MACheckboxWidget class methodsFor: 'testing' stamp: 'np 4/13/2009 15:34'!
isAbstract
	^false! !

!MACheckboxWidget methodsFor: 'building' stamp: 'np 6/3/2009 11:36'!
editorContents
	^[:e || label |
	label := e label.
	label checkbox
		id: self labelId;
		disabled: self isReadonly;
		action: [:val | self value: val];
		checked: self value = true.
	e space; text: self description label]! !

!MACheckboxWidget methodsFor: 'testing' stamp: 'np 4/13/2009 15:24'!
hasLabelId
	^true! !

!MAElementWidget methodsFor: 'show/answer' stamp: 'np 4/20/2009 16:39'!
chooser: aWidget
	self chooser: aWidget titled: 'Edit ' , self description label! !

!MAElementWidget methodsFor: 'show/answer' stamp: 'sa 9/21/2009 11:20'!
chooser: aWidget titled: aString
	self root
		show: (aWidget
			addMessage: [:e | e h3: aString];
			yourself)
		onAnswer: [:ans |
			ans isNil ifFalse: [self value: ans]]
	! !

!MAElementWidget methodsFor: 'building' stamp: 'np 4/18/2009 19:05'!
contents
	^[:e | self isReadonly 
			ifTrue: [e build: self viewerContents]
			ifFalse: [e build: self editorContents]]! !

!MAElementWidget methodsFor: 'building' stamp: 'np 4/19/2009 18:51'!
editorContents
	^self viewerContents! !

!MAElementWidget methodsFor: 'testing' stamp: 'np 4/13/2009 15:23'!
hasLabelId
	"Return whether somewhere an element is rendered with the id ==labelId== that can be reference by a <label>-tag."

	^false! !

!MAElementWidget methodsFor: 'accessing' stamp: 'np 4/13/2009 15:22'!
reference
	^self description reference! !

!MAElementWidget methodsFor: 'accessing-model' stamp: 'np 4/13/2009 15:21'!
string
	^self value isString
		ifTrue: [self value]
		ifFalse: [self description toString: self value]! !

!MAElementWidget methodsFor: 'accessing-model' stamp: 'np 4/13/2009 15:22'!
string: aString
	| value |
	value := [self description fromString: aString]
		ifError: [aString].
	self value: value! !

!MAElementWidget methodsFor: 'accessing-model' stamp: 'np 4/13/2009 15:22'!
value
	^self memento readUsing: self description! !

!MAElementWidget methodsFor: 'accessing-model' stamp: 'np 4/13/2009 15:22'!
value: anObject
	self memento write: anObject using: self description! !

!MAElementWidget methodsFor: 'building' stamp: 'np 6/3/2009 11:39'!
viewerContents
	^[:e |
		e text: self string]! !

MAElementWidget subclass: #MAFileUploadWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Widgets'!

!MAFileUploadWidget commentStamp: 'np 4/13/2009 15:57' prior: 0!
I'm the MAFileDescription Iliad widget. With me user can upload files to the server. I provide a button for the user to browse their computer for files.!

!MAFileUploadWidget class methodsFor: 'as yet unclassified' stamp: 'np 4/13/2009 15:56'!
isAbstract
	^false! !

!MAFileUploadWidget methodsFor: 'building' stamp: 'np 4/21/2009 10:22'!
editorContents
	^[:e |
		(self value isNil or: [self value isEmpty])
			ifTrue: [e build: self uploadContents]
			ifFalse: [e build: self removeContents]]! !

!MAFileUploadWidget methodsFor: 'testing' stamp: 'np 4/20/2009 20:17'!
hasLabelId
	^self isReadonly not and: [self isMultipart]! !

!MAFileUploadWidget methodsFor: 'testing' stamp: 'np 4/21/2009 10:22'!
isMultipart
	^true! !

!MAFileUploadWidget methodsFor: 'actions' stamp: 'np 4/20/2009 20:16'!
remove
	self markDirty.
	self value ifNotNil: [self value finalize].
	self value: nil! !

!MAFileUploadWidget methodsFor: 'building' stamp: 'np 4/20/2009 20:21'!
removeContents
	^[:e |
		e text: self value filename.
		e text: ' (', self value filesize asFileSize, ') '.
		e button 
			action: [self remove];
			text: 'remove']! !

!MAFileUploadWidget methodsFor: 'actions' stamp: 'np 4/21/2009 10:24'!
upload: aFile
	self markDirty.
	self value: ((aFile isKindOf: ILFileProxy) ifTrue: [
		self description kind new
			mimetype: aFile contentType;
			filename: aFile filename;
			contents: aFile contents;
			yourself])! !

!MAFileUploadWidget methodsFor: 'building' stamp: 'np 10/1/2009 00:15'!
uploadContents
	^[:e |
		e file
			id: self labelId;
			action: [:val | self upload: val].
		e button
			text: 'upload']! !

!MAFileUploadWidget methodsFor: 'building' stamp: 'np 4/20/2009 21:01'!
viewerContents
	^[:e | 
		e text: self value]! !

MAElementWidget subclass: #MAOptionWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Widgets'!

MAOptionWidget subclass: #MAMultipleSelectionWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Widgets'!

!MAMultipleSelectionWidget commentStamp: 'np 4/16/2009 17:52' prior: 0!
I provide basic functionalities for MACheckboxGroupWidget.!

MAMultipleSelectionWidget subclass: #MACheckboxGroupWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Widgets'!

!MACheckboxGroupWidget commentStamp: 'np 4/20/2009 16:04' prior: 0!
Use for MAMultipleSelectionWidget. I display as many checkboxes as my description has options.!

!MACheckboxGroupWidget class methodsFor: 'testing' stamp: 'np 4/17/2009 18:04'!
isAbstract
	^false! !

!MACheckboxGroupWidget methodsFor: 'building' stamp: 'np 10/1/2009 00:12'!
editorContents
	^[:e |
		e input
			beHidden
			action: [self clear].
		self optionsWithIndexDo: [:each :index |
			| optionId |
			optionId := self optionId: index.
			e checkbox
				id: optionId;
				checked: (self selectedList includes: each);
				action: [:val | val 
					ifTrue: [self add: each]
					ifFalse: [self remove: each]].
			e space.
			e label
				for: optionId;
				text: (self labelForOption: each)]
		separatedBy: [e br]]! !

!MACheckboxGroupWidget methodsFor: 'testing' stamp: 'np 4/17/2009 18:04'!
hasLabelId
	^self isReadonly! !

!MACheckboxGroupWidget methodsFor: 'testing' stamp: 'np 4/17/2009 18:04'!
isDistinct
	^true! !

!MACheckboxGroupWidget methodsFor: 'private' stamp: 'np 4/5/2010 17:48'!
optionId: anInteger
	^self id: 'option', anInteger greaseString! !

!MACheckboxGroupWidget methodsFor: 'private' stamp: 'np 4/20/2009 16:09'!
optionsWithIndexDo: elementAndIndexBlock separatedBy: separatorBlock
	| index |
	index := 1.
	self description allOptions
		do: [:each |
			elementAndIndexBlock value: each value: index.
			index := index + 1]
		separatedBy: separatorBlock! !

!MAMultipleSelectionWidget methodsFor: 'actions' stamp: 'np 4/20/2009 15:37'!
add: anObject
	(self isDistinct and: [self value includes: anObject]) ifFalse: [
			self value: (self value copyWith: anObject)]! !

!MAMultipleSelectionWidget methodsFor: 'accessing' stamp: 'np 4/16/2009 17:53'!
availableList
	^self description allOptions! !

!MAMultipleSelectionWidget methodsFor: 'actions' stamp: 'np 4/17/2009 18:09'!
clear
	self value: self value copyEmpty! !

!MAMultipleSelectionWidget methodsFor: 'testing' stamp: 'np 4/16/2009 17:53'!
hasLabelId
	^true! !

!MAMultipleSelectionWidget methodsFor: 'testing' stamp: 'np 4/16/2009 17:53'!
isDistinct
	^self description isDistinct! !

!MAMultipleSelectionWidget methodsFor: 'testing' stamp: 'np 4/16/2009 17:53'!
isOrdered
	^self description isOrdered
		and: [(self value respondsTo: #moveUp:)
		and: [self value respondsTo: #moveDown:]]! !

!MAMultipleSelectionWidget methodsFor: 'actions' stamp: 'np 4/17/2009 18:09'!
remove: anObject
	self value: (self isDistinct
		ifTrue: [self value copyWithout: anObject]
		ifFalse: [self value copyWithoutFirst: anObject])! !

!MAMultipleSelectionWidget methodsFor: 'accessing' stamp: 'np 4/16/2009 17:53'!
selectedList
	^self value! !

!MAMultipleSelectionWidget methodsFor: 'accessing' stamp: 'np 4/16/2009 17:53'!
value
	^super value ifNil: [self value: Array new. super value]! !

!MAMultipleSelectionWidget methodsFor: 'building' stamp: 'np 10/1/2009 00:21'!
viewerContents
	^[:e || list |
		list := e ul.
		self selectedList do: [:each |
			list li
				id: self labelId;
				text: (self labelForOption: each)]]! !

MAMultipleSelectionWidget subclass: #MAMultiselectListWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Widgets'!

!MAMultiselectListWidget class methodsFor: 'testing' stamp: 'np 4/17/2009 18:35'!
isAbstract
	^false! !

!MAMultiselectListWidget methodsFor: 'building' stamp: 'np 4/20/2009 15:31'!
editorContents
	^[:e || select |
		select := e select
			beMultiple;
			size: 8;
			id: self labelId;
			yourself.
		self availableList do: [:each || option |
			option := select option
				text: (self labelForOption: each);
				action: [self add: each];
				yourself.
			option selected: (self selectedList includes: each)]]! !

!MAMultiselectListWidget methodsFor: 'testing' stamp: 'np 4/17/2009 18:33'!
isDistinct
	^true! !

!MAOptionWidget methodsFor: 'private' stamp: 'np 4/16/2009 17:56'!
labelForOption: anObject
	^self description labelForOption: anObject! !

MAOptionWidget subclass: #MASingleSelectionWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Widgets'!

MASingleSelectionWidget subclass: #MASelectListWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Widgets'!

!MASelectListWidget commentStamp: 'np 4/20/2009 15:58' prior: 0!
I display a simple list to allow the user to choose one element from the list!

!MASelectListWidget class methodsFor: 'testing' stamp: 'np 4/17/2009 18:45'!
isAbstract
	^false! !

!MASelectListWidget methodsFor: 'building' stamp: 'np 4/17/2009 18:47'!
editorContents
	^[:e |
		self description isGrouped
			ifTrue: [e build: self editorForGroupedContents]
			ifFalse: [e build: self editorForUngroupedContents]]! !

!MASelectListWidget methodsFor: 'building-grouped' stamp: 'np 4/17/2009 20:13'!
editorForGroupedContents
	^[:e |
		e select 
			id: self labelId;
			build: self groupsContents]! !

!MASelectListWidget methodsFor: 'building' stamp: 'np 4/20/2009 15:57'!
editorForUngroupedContents
	^[:e || select |
		select := e select
			id: self labelId;
			yourself.
		self options do: [:each |
			select option
				selected: self value = each;
				action: [self value: each];
				text: (self labelForOption: each)]]! !

!MASelectListWidget methodsFor: 'accessing-model' stamp: 'np 4/17/2009 18:45'!
groups
	"The options objects are assumed to understand the 'groupBy' selector supplied by the description object. Keep the global ordering intact."

	| groups group |
	groups := OrderedCollection new.
	self options do: [:option | 
		option isNil ifFalse: [
			group := self description groupBy read: option.
			(groups
				detect: [:each | each key = group]
				ifNone: [groups addLast: group -> OrderedCollection new])
					value addLast: option]].
	^ groups! !

!MASelectListWidget methodsFor: 'building-grouped' stamp: 'np 10/1/2009 00:25'!
groupsContents
	^[:e |
		self groups do: [:association || optgroup |
		optgroup := e optgroup
			label: association key;
			yourself. 
		association value do: [:option | 
			optgroup build: (self optionContentsFor: option)]]]! !

!MASelectListWidget methodsFor: 'testing' stamp: 'np 4/17/2009 18:45'!
hasLabelId
	^self isReadonly not! !

!MASelectListWidget methodsFor: 'building-grouped' stamp: 'np 4/20/2009 15:56'!
optionContentsFor: option
	^[:e |
		e option
			selected: self value = option;
			text: (self labelForOption: option);
			action: [self value: option]]! !

!MASingleSelectionWidget methodsFor: 'accessing' stamp: 'np 4/17/2009 18:38'!
options
	^self description allOptionsWith: self value! !

!MASingleSelectionWidget methodsFor: 'building' stamp: 'np 4/17/2009 18:38'!
viewerContents
	^[:e |
		e text: (self labelForOption: self value)]! !

MAElementWidget subclass: #MARelationWidget
	instanceVariableNames: 'selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Widgets'!

MARelationWidget subclass: #MAOneToManyWidget
	instanceVariableNames: 'report commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Widgets'!

!MAOneToManyWidget class methodsFor: 'testing' stamp: 'np 7/12/2009 19:43'!
isAbstract
	^ false! !

!MAOneToManyWidget methodsFor: 'actions' stamp: 'sa 9/21/2009 11:22'!
add
	self root 
		show: ((self selected new asWidget)
			addMessage: [:e | e h3: 'Add ' , self selected label];
			addValidatedForm;
			yourself)
		onAnswer: [:ans | 
			ans ifNotNil: [self value: (self value copyWith: ans); refresh]]! !

!MAOneToManyWidget methodsFor: 'private' stamp: 'np 7/12/2009 19:55'!
buildCommands
	commands := MACommandColumnWidget new setReport: self report.
	self description isDefinitive ifFalse: [
		commands
			addCommandOn: self selector: #edit: text: 'edit';
			addCommandOn: self selector: #remove: text: 'remove' ].
	self description isOrdered ifTrue: [
		commands
			addCommandOn: self selector: #up: text: 'up';
			addCommandOn: self selector: #down: text: 'down' ].
	^ commands! !

!MAOneToManyWidget methodsFor: 'private' stamp: 'np 7/12/2009 19:44'!
buildReport
	^ (MAReportWidget rows: self value description: self reference)
		sortEnabled: self description isOrdered not;
		yourself! !

!MAOneToManyWidget methodsFor: 'accessing' stamp: 'np 7/12/2009 19:43'!
children
	^ Array with: self report! !

!MAOneToManyWidget methodsFor: 'accessing' stamp: 'np 7/12/2009 19:43'!
commands
	^ commands ifNil: [ commands := self buildCommands ]! !

!MAOneToManyWidget methodsFor: 'actions' stamp: 'np 7/12/2009 19:43'!
down: anElement
	self value moveDown: anElement! !

!MAOneToManyWidget methodsFor: 'actions' stamp: 'np 9/18/2009 13:42'!
edit: anObject
	self root show: (anObject asWidget
		addMessage: [:e | e h3: 'Edit ' , self selected label];
		addValidatedForm;
		yourself).
	self refresh! !

!MAOneToManyWidget methodsFor: 'building' stamp: 'np 7/12/2009 19:47'!
editorContents
	^[:e |
	e build: self viewerContents.
	self description isDefinitive
		ifFalse: [e build: self selectListContents]]! !

!MAOneToManyWidget methodsFor: 'actions' stamp: 'np 7/12/2009 19:43'!
refresh
	self report rows: self value! !

!MAOneToManyWidget methodsFor: 'actions' stamp: 'np 7/12/2009 19:43'!
remove: anObject
	self value: (self value copyWithout: anObject).
	self refresh! !

!MAOneToManyWidget methodsFor: 'accessing' stamp: 'np 7/12/2009 19:43'!
report
	^ report ifNil: [ report := self buildReport ]! !

!MAOneToManyWidget methodsFor: 'building-buttons' stamp: 'np 7/12/2009 20:10'!
selectButtonContents
	^[:e |
		e button 
			text: 'Add';
			action: [self add]]! !

!MAOneToManyWidget methodsFor: 'actions' stamp: 'np 7/12/2009 19:43'!
up: anElement
	self value moveUp: anElement! !

!MAOneToManyWidget methodsFor: 'building' stamp: 'np 7/12/2009 19:47'!
viewerContents
	^[:e || columns |
	columns := self report columns
		copyWithout: self commands.
	self report columns: (self isReadonly
		ifFalse: [ columns copyWith: self commands ]
		ifTrue: [ columns ]).
	e build: self report]! !

MARelationWidget subclass: #MAOneToOneWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Widgets'!

MAOneToOneWidget subclass: #MAExternalEditorWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Widgets'!

!MAExternalEditorWidget class methodsFor: 'testing' stamp: 'np 4/15/2009 12:30'!
isAbstract
	^false! !

!MAExternalEditorWidget methodsFor: 'building' stamp: 'np 4/15/2009 12:29'!
buttonsContents
	^[:e |
		e button
			action: [self remove];
			text: 'remove'.
		e button 
			action: [self edit];
			text: 'edit']! !

!MAExternalEditorWidget methodsFor: 'actions' stamp: 'np 4/17/2009 18:11'!
create
	self chooser: (self editorFor: self selected new)! !

!MAExternalEditorWidget methodsFor: 'actions' stamp: 'np 4/17/2009 18:11'!
edit
	self chooser: (self editorFor: self value)! !

!MAExternalEditorWidget methodsFor: 'building' stamp: 'np 6/3/2009 11:40'!
viewerContents
	^[:e |
		e text: (self reference toString: self value)]! !

MAOneToOneWidget subclass: #MAInternalEditorWidget
	instanceVariableNames: 'widget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Widgets'!

!MAInternalEditorWidget class methodsFor: 'testing' stamp: 'np 4/15/2009 12:09'!
isAbstract
	^false! !

!MAInternalEditorWidget methodsFor: 'private' stamp: 'np 4/20/2009 19:45'!
buildWidget
	^ self value asWidget
		setParent: self;
		yourself! !

!MAInternalEditorWidget methodsFor: 'accessing' stamp: 'np 4/20/2009 19:39'!
children
	^ Array with: self widget! !

!MAInternalEditorWidget methodsFor: 'actions' stamp: 'np 4/20/2009 19:45'!
create
	self value: self selected new.
	widget := nil.
	self markDirty! !

!MAInternalEditorWidget methodsFor: 'building' stamp: 'np 4/15/2009 12:07'!
viewerContents
	^[:e |
		e add: (self widget
		readonly: self isReadonly;
		build)]! !

!MAInternalEditorWidget methodsFor: 'accessing' stamp: 'np 4/15/2009 12:09'!
widget
	^widget ifNil: [widget := self buildWidget]! !

!MAOneToOneWidget methodsFor: 'building' stamp: 'np 4/15/2009 12:20'!
buttonsContents
	^[:e | ]! !

!MAOneToOneWidget methodsFor: 'actions' stamp: 'np 4/15/2009 12:17'!
create
	self subclassResponsibility! !

!MAOneToOneWidget methodsFor: 'building' stamp: 'np 4/15/2009 12:20'!
editorContents
	^[:e |
		self value isNil
			ifTrue: [e build: self selectListContents]
			ifFalse: [e build: self viewerContents. 
					e build: self buttonsContents]]! !

!MAOneToOneWidget methodsFor: 'actions' stamp: 'np 4/17/2009 18:12'!
remove
	self value: nil! !

!MAOneToOneWidget methodsFor: 'building-tools' stamp: 'np 4/20/2009 16:38'!
selectButtonContents
	^[:e |
		e button 
			action: [self create];
			text: 'Create']! !

!MARelationWidget methodsFor: 'accessing-dynamic' stamp: 'np 4/15/2009 12:11'!
classes
	^self description classes! !

!MARelationWidget methodsFor: 'private' stamp: 'np 4/15/2009 12:11'!
editorFor: anObject
	^(self description reference asWidgetOn: anObject)
		addValidatedForm;
		yourself! !

!MARelationWidget methodsFor: 'building-tools' stamp: 'np 4/15/2009 12:17'!
selectButtonContents
	self subclassResponsibility! !

!MARelationWidget methodsFor: 'building-tools' stamp: 'np 4/20/2009 16:37'!
selectListContents
	^[:e || select |
		self classes size > 1 ifTrue: [
			select := e select.
			self classes do: [:each |
				select option
					value: each label;
					selected: each = self selected;
					action: [self selected: each]]].
		self classes notEmpty
			ifTrue: [e build: self selectButtonContents]]! !

!MARelationWidget methodsFor: 'accessing' stamp: 'np 4/15/2009 12:11'!
selected
	^selected ifNil: [selected := self classes first]! !

!MARelationWidget methodsFor: 'accessing' stamp: 'np 4/15/2009 12:10'!
selected: aClass
	selected := aClass! !

MAElementWidget subclass: #MATextAreaWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Widgets'!

!MATextAreaWidget commentStamp: 'np 4/17/2009 20:14' prior: 0!
I display an html text area for the magritte MAMemoDescription.!

!MATextAreaWidget class methodsFor: 'testing' stamp: 'np 4/17/2009 20:15'!
isAbstract
	^false! !

!MATextAreaWidget methodsFor: 'buidling' stamp: 'np 10/1/2009 00:35'!
editorContents
	^[:e |
		e textarea
			id: self labelId;
			rows: self description lineCount;
			text: self string;
			action: [:val | self string: val]]! !

!MATextAreaWidget methodsFor: 'testing' stamp: 'np 4/17/2009 20:15'!
hasLabelId
	^self isReadonly not! !

!MATextAreaWidget methodsFor: 'buidling' stamp: 'np 10/1/2009 00:12'!
viewerContents
	^[:e |
		(self string findTokens: Character cr)
			do: [ :each | e text: each ]
			separatedBy: [e br]]! !

MAElementWidget subclass: #MATextInputWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Widgets'!

!MATextInputWidget commentStamp: 'np 4/17/2009 20:17' prior: 0!
I'm a simple input box for MAStringDescription.!

MATextInputWidget subclass: #MADateSelectorWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Widgets'!

!MADateSelectorWidget methodsFor: 'building' stamp: 'np 4/21/2009 15:21'!
buttonsContents
	^[:e |
		e button
			text: 'choose';
			action: [self choose]]! !

!MADateSelectorWidget methodsFor: 'actions' stamp: 'np 7/5/2009 18:57'!
choose
	| selector |
	selector := ILDateSelector new.
	selector 
		selectedDate: ((self value notNil
			and: [self description isSatisfiedBy: self value])
				ifFalse: [Date current]
				ifTrue: [self value]).
	self chooser: selector! !

!MATextInputWidget class methodsFor: 'testing' stamp: 'np 4/17/2009 20:17'!
isAbstract
	^ false! !

!MATextInputWidget methodsFor: 'rendering' stamp: 'np 4/17/2009 20:18'!
buttonsContents
	^[:e | ]! !

!MATextInputWidget methodsFor: 'rendering' stamp: 'np 4/17/2009 20:18'!
editorContents
	^[:e |
		e build: self inputContents.
		e build: self buttonsContents]! !

!MATextInputWidget methodsFor: 'testing' stamp: 'np 4/17/2009 20:17'!
hasLabelId
	^self isReadonly not! !

!MATextInputWidget methodsFor: 'rendering' stamp: 'np 9/30/2009 23:59'!
inputContents
	^[:e |
		e input
		id: self labelId;
		value: self string;
		action: [:val | self string: val]]! !

MATextInputWidget subclass: #MATimeSelectorWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Widgets'!

!MATimeSelectorWidget methodsFor: 'building' stamp: 'np 4/21/2009 15:37'!
buttonsContents
	^[:e |
		e button
			text: 'choose';
			action: [self choose]]! !

!MATimeSelectorWidget methodsFor: 'actions' stamp: 'np 7/5/2009 18:57'!
choose
	| selector |
	selector := ILTimeSelector new.
	selector 
		showSeconds: true;
		selectedTime: ((self value notNil
			and: [self description isSatisfiedBy: self value])
				ifFalse: [Time current]
				ifTrue: [self value]).
	self chooser: selector! !

MATextInputWidget subclass: #MATimeStampSelectorWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Widgets'!

!MATimeStampSelectorWidget methodsFor: 'building' stamp: 'np 4/21/2009 15:41'!
buttonsContents
	^[:e |
		e button
			text: 'now';
			action: [self now]]! !

!MATimeStampSelectorWidget methodsFor: 'actions' stamp: 'np 4/21/2009 15:41'!
now
	self markDirty.
	self value: TimeStamp current! !

MAElementWidget subclass: #MATextPasswordWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Widgets'!

!MATextPasswordWidget commentStamp: 'np 4/17/2009 20:38' prior: 0!
Password iliad widget, I display stars '*' instead of the text typed by the user. My description is MAPasswordDescription.!

!MATextPasswordWidget class methodsFor: 'testing' stamp: 'np 4/17/2009 20:40'!
isAbstract
	^false! !

!MATextPasswordWidget methodsFor: 'building' stamp: 'np 10/1/2009 00:26'!
editorContents
	^[:e |
		e password
			id: self labelId;
			value: self string;
			action: [:val | self string: val]]! !

!MATextPasswordWidget methodsFor: 'testing' stamp: 'np 4/17/2009 20:39'!
hasLabelId
	^self isReadonly not! !

!MATextPasswordWidget methodsFor: 'accessing' stamp: 'np 4/17/2009 20:40'!
string
	^self description obfuscated: super string! !

!MATextPasswordWidget methodsFor: 'accessing' stamp: 'np 4/17/2009 20:38'!
string: aString
	(self description isObfuscated: aString)
		ifFalse: [ super string: aString ]! !

MATextPasswordWidget subclass: #MAVerifiedPasswordWidget
	instanceVariableNames: 'verificationValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Widgets'!

!MAVerifiedPasswordWidget methodsFor: 'private' stamp: 'np 4/17/2009 20:41'!
doValidate
	self value = verificationValue
		ifFalse: [^ MAConditionError description: self description signal: 'Your passwords do not match'].
	super doValidate! !

!MAVerifiedPasswordWidget methodsFor: 'buidling' stamp: 'np 10/1/2009 00:26'!
editorContents
	^[:e |
		e build: super editorContents.
		e br.
		e password
			class: 'verification';
			value: self verificationString;
			action: [:val | self verificationString: val]]! !

!MAVerifiedPasswordWidget methodsFor: 'initialization' stamp: 'np 4/17/2009 20:40'!
setDescription: aDescription
	super setDescription: aDescription.
	self verificationValue: self value! !

!MAVerifiedPasswordWidget methodsFor: 'accessing' stamp: 'np 4/17/2009 20:40'!
verificationString
	^ self description obfuscated: self verificationValue! !

!MAVerifiedPasswordWidget methodsFor: 'accessing' stamp: 'np 4/17/2009 20:42'!
verificationString: aString
	| value |
	(self description isObfuscated: aString)
		ifTrue: [^ self].
	value := [self description fromString: aString]
		ifError: [aString].
	self verificationValue: value! !

!MAVerifiedPasswordWidget methodsFor: 'accessing' stamp: 'np 4/17/2009 20:42'!
verificationValue
	^verificationValue! !

!MAVerifiedPasswordWidget methodsFor: 'accessing' stamp: 'np 4/17/2009 20:40'!
verificationValue: anObject
	verificationValue := anObject! !

MAElementWidget subclass: #MAUndefinedWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Widgets'!

!MAUndefinedWidget class methodsFor: 'testing' stamp: 'np 4/17/2009 20:43'!
isAbstract
	^ false! !

!MAUndefinedWidget methodsFor: 'building' stamp: 'np 4/17/2009 20:44'!
contents
	^[:e |
		e span
			id: self labelId;
			style: 'color: red;';
			text: 'Undefined Component']! !

!MAUndefinedWidget methodsFor: 'testing' stamp: 'np 4/17/2009 20:43'!
hasLabelId
	^true! !

MAWidget subclass: #MAReportWidget
	instanceVariableNames: 'rows cache columns properties backtracked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Report'!

!MAReportWidget class methodsFor: 'accessing-description-table' stamp: 'np 5/22/2009 14:08'!
description2000
	^ MABooleanDescription new
		accessor: #showHeader;
		label: 'Show Header';
		priority: 2000;
		yourself! !

!MAReportWidget class methodsFor: 'accessing-description-table' stamp: 'np 5/22/2009 14:08'!
description2100
	^ MABooleanDescription new
		accessor: #showBody;
		label: 'Show Body';
		priority: 2100;
		yourself! !

!MAReportWidget class methodsFor: 'accessing-description-table' stamp: 'np 5/22/2009 14:08'!
description2200
	^ MAStringDescription new
		accessor: #tableEmpty;
		label: 'Empty';
		priority: 2200;
		yourself! !

!MAReportWidget class methodsFor: 'accessing-description-table' stamp: 'np 5/22/2009 14:08'!
description2300
	^ MABooleanDescription new
		accessor: #showFooter;
		label: 'Show Footer';
		priority: 2300;
		yourself! !

!MAReportWidget class methodsFor: 'accessing-description-table' stamp: 'np 5/22/2009 14:08'!
description2400
	^ MABooleanDescription new
		accessor: #showCaption;
		label: 'Show Caption';
		priority: 2300;
		yourself! !

!MAReportWidget class methodsFor: 'accessing-description-table' stamp: 'np 5/22/2009 14:08'!
description2500
	^ MAStringDescription new
		accessor: #tableCaption;
		label: 'Caption';
		priority: 2500;
		yourself! !

!MAReportWidget class methodsFor: 'accessing-description-table' stamp: 'np 5/22/2009 14:08'!
description2600
	^ MABooleanDescription new
		accessor: #showSummary;
		label: 'Show Summary';
		priority: 2600;
		yourself! !

!MAReportWidget class methodsFor: 'accessing-description-table' stamp: 'np 5/22/2009 14:08'!
description2700
	^ MAStringDescription new
		accessor: #tableSummary;
		label: 'Summary';
		priority: 2700;
		yourself! !

!MAReportWidget class methodsFor: 'accessing-description-batch' stamp: 'np 5/22/2009 14:08'!
description4000
	^ MABooleanDescription new
		accessor: #showBatch;
		label: 'Show Batch';
		priority: 4000;
		yourself! !

!MAReportWidget class methodsFor: 'accessing-description-batch' stamp: 'np 5/22/2009 14:08'!
description4100
	^ MANumberDescription new
		accessor: #batchSize;
		label: 'Size';
		priority: 4100;
		yourself! !

!MAReportWidget class methodsFor: 'accessing-description-batch' stamp: 'np 5/22/2009 14:08'!
description4200
	^ MABooleanDescription new
		accessor: #showBatchFirstLast;
		label: 'Show First/Last';
		priority: 4200;
		yourself! !

!MAReportWidget class methodsFor: 'accessing-description-batch' stamp: 'np 5/22/2009 14:08'!
description4300
	^ MABooleanDescription new
		accessor: #showBatchPreviousNext;
		label: 'Show Previous/Next';
		priority: 4300;
		yourself! !

!MAReportWidget class methodsFor: 'accessing-description-batch' stamp: 'np 5/22/2009 14:08'!
description4400
	^ MABooleanDescription new
		accessor: #showBatchPages;
		label: 'Show Pages';
		priority: 4400;
		yourself! !

!MAReportWidget class methodsFor: 'testing' stamp: 'np 5/22/2009 14:08'!
isAbstract
	^ false! !

!MAReportWidget class methodsFor: 'instance creation' stamp: 'np 5/22/2009 14:08'!
rows: aCollection
	^ self new
		rows: aCollection;
		yourself! !

!MAReportWidget class methodsFor: 'instance creation' stamp: 'np 5/22/2009 14:08'!
rows: aCollection description: aDescription
	| report |
	report := self rows: aCollection.
	aDescription asContainer do: [ :each |
		report addColumnDescription: each ].
	^ report! !

!MAReportWidget methodsFor: 'columns' stamp: 'np 5/22/2009 14:08'!
addColumn: aColumn
	columns := columns copyWith: aColumn.
	^ aColumn setReport: self; yourself! !

!MAReportWidget methodsFor: 'columns' stamp: 'np 5/22/2009 14:39'!
addColumnCascade: anArray
	^ (self addColumn: MAColumnWidget new)
		cascade: anArray;
		yourself! !

!MAReportWidget methodsFor: 'columns' stamp: 'np 5/22/2009 14:44'!
addColumnDescription: aDescription
	^ self addColumn: (aDescription reportColumnWidgetClass new
		setDescription: aDescription;
		yourself)! !

!MAReportWidget methodsFor: 'columns' stamp: 'np 5/22/2009 14:39'!
addColumnSelector: aSelector
	^ (self addColumn: MAColumnWidget new)
		selector: aSelector;
		yourself! !

!MAReportWidget methodsFor: 'private-batch' stamp: 'np 5/22/2009 14:08'!
batchEndIndex
	^ self batchPage * self batchSize min: self cache size! !

!MAReportWidget methodsFor: 'building-batch' stamp: 'np 10/1/2009 00:06'!
batchFirstContents
	^[:e |
		self isOnFirstPage
			ifFalse: [e a action: [self batchPage: self defaultBatchPage]; text: '|<' ]
			ifTrue: [e text: '|<'].
		e space]! !

!MAReportWidget methodsFor: 'building-batch' stamp: 'np 4/5/2010 17:48'!
batchItemsContents
	^[:e |
		self batchPageRangeStart > self defaultBatchPage ifTrue: [ 
			e text: '...'; space].
		self batchPageRange do: [:index |
			self batchPage = index
				ifFalse: [e a action: [self batchPage: index]; text: index printString]
				ifTrue: [e span class: 'current'; text: index printString].
			e space].
		self batchPageRangeEnd < (self batchMaxPages - 1) ifTrue: [
			e text: '...'; space].
		self batchPageRangeEnd = self batchMaxPages ifFalse: [
			e a
				action: [self batchPage: self batchMaxPages];
				text: self batchMaxPages greaseString]]! !

!MAReportWidget methodsFor: 'building-batch' stamp: 'np 10/1/2009 00:07'!
batchLastContents
	^[:e |
		self isOnLastPage
			ifFalse: [e a action: [self batchPage: self batchMaxPages]; text: '>|' ]
			ifTrue: [e text: '>|']]! !

!MAReportWidget methodsFor: 'private-batch' stamp: 'np 5/22/2009 14:08'!
batchMaxPages
	^ (self cache size / self batchSize)
		ceiling! !

!MAReportWidget methodsFor: 'building-batch' stamp: 'np 10/1/2009 00:07'!
batchNextContents
	^[:e |
		self isOnLastPage
			ifFalse: [e a action: [self nextPage]; text: '>>']
			ifTrue: [e text: '>>'].
	e space]! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
batchPage
	^ backtracked at: #batchPage ifAbsentPut: [ self defaultBatchPage ]! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 15:12'!
batchPage: anInteger
	backtracked at: #batchPage put: anInteger.
	self markDirty! !

!MAReportWidget methodsFor: 'private-batch' stamp: 'np 5/22/2009 14:08'!
batchPageRange
	^ self batchPageRangeStart to: self batchPageRangeEnd! !

!MAReportWidget methodsFor: 'private-batch' stamp: 'np 5/22/2009 14:08'!
batchPageRangeEnd
	^ self batchMaxPages min: self batchPage + 9! !

!MAReportWidget methodsFor: 'private-batch' stamp: 'np 5/22/2009 14:08'!
batchPageRangeStart
	^ self defaultBatchPage max: self batchPage - 9! !

!MAReportWidget methodsFor: 'building-batch' stamp: 'np 10/1/2009 00:07'!
batchPreviousContents
	^[:e |
		self isOnFirstPage
			ifFalse: [e a action: [self previousPage]; text: '<<']
			ifTrue: [e text: '<<'].
		e space]! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
batchSize
	^ properties at: #batchSize ifAbsent: [ self defaultBatchSize ]! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
batchSize: anInteger
	properties at: #batchSize put: anInteger! !

!MAReportWidget methodsFor: 'private-batch' stamp: 'np 5/22/2009 14:08'!
batchStartIndex
	^ (self batchPage - 1) * self batchSize + 1! !

!MAReportWidget methodsFor: 'accessing-readonly' stamp: 'np 5/22/2009 14:08'!
cache
	"Return the cached rows of the receiver, these rows are filtered and sorted."

	cache isNil ifTrue: [
		self cache: (self
			sortRows: (self
				filterRows: self
					rows asArray)) ].
	^ cache! !

!MAReportWidget methodsFor: 'accessing-readonly' stamp: 'np 5/22/2009 14:08'!
cache: aCollection
	cache := aCollection! !

!MAReportWidget methodsFor: 'accessing-readonly' stamp: 'np 5/22/2009 14:08'!
columns
	^ columns! !

!MAReportWidget methodsFor: 'accessing-readonly' stamp: 'np 5/22/2009 14:08'!
columns: aCollection
	columns := aCollection! !

!MAReportWidget methodsFor: 'building' stamp: 'np 5/22/2009 14:33'!
contents
	^[:e |
		e table
			class: 'report';
			build: self tableContents]! !

!MAReportWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 14:08'!
defaultBatchPage
	^ 1! !

!MAReportWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 14:08'!
defaultBatchSize
	^ 10! !

!MAReportWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 14:08'!
defaultRowFilter
	^ nil! !

!MAReportWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 14:08'!
defaultRowPeriod
	^ 1! !

!MAReportWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 14:08'!
defaultRowStyles
	^ Array with: 'odd' with: 'even'! !

!MAReportWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 14:08'!
defaultShowBatch
	^ true! !

!MAReportWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 14:08'!
defaultShowBatchFirstLast
	^ false! !

!MAReportWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 14:08'!
defaultShowBatchPages
	^ true! !

!MAReportWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 14:08'!
defaultShowBatchPreviousNext
	^ true! !

!MAReportWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 14:08'!
defaultShowBody
	^ true! !

!MAReportWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 14:08'!
defaultShowCaption
	^ false! !

!MAReportWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 14:08'!
defaultShowFooter
	^ false! !

!MAReportWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 14:08'!
defaultShowHeader
	^ true! !

!MAReportWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 14:08'!
defaultShowSummary
	^ false! !

!MAReportWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 14:08'!
defaultSortColumn
	^ nil! !

!MAReportWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 14:08'!
defaultSortEnabled
	^ true! !

!MAReportWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 14:08'!
defaultSortReversed
	^ false! !

!MAReportWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 14:08'!
defaultSorterStyles
	^ Array with: 'ascending' with: 'descending'! !

!MAReportWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 14:08'!
defaultTableCaption
	^ nil! !

!MAReportWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 14:08'!
defaultTableEmpty
	^ 'The report is empty.'! !

!MAReportWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 14:08'!
defaultTableSummary
	^ nil! !

!MAReportWidget methodsFor: 'exporting' stamp: 'np 5/22/2009 14:08'!
export
	^ String streamContents: [ :stream |
		self exportOn: stream ]! !

!MAReportWidget methodsFor: 'exporting' stamp: 'np 5/22/2009 14:08'!
exportBodyOn: aStream
	self cache withIndexDo: [ :row :index |
		self visibleColumns
			do: [ :column |
				column
					exportContent: (column valueFor: row)
					index: index on: aStream ]
			separatedBy: [ aStream tab ].
		aStream cr ]! !

!MAReportWidget methodsFor: 'exporting' stamp: 'np 5/22/2009 14:08'!
exportHeaderOn: aStream
	self visibleColumns
		do: [ :each | each exportHeadOn: aStream ]
		separatedBy: [ aStream tab ].
	aStream cr! !

!MAReportWidget methodsFor: 'exporting' stamp: 'np 5/22/2009 14:08'!
exportOn: aStream
	self showHeader
		ifTrue: [ self exportHeaderOn: aStream ].
	self showBody
		ifTrue: [ self exportBodyOn: aStream ]! !

!MAReportWidget methodsFor: 'private' stamp: 'np 5/22/2009 14:08'!
filterRows: aCollection
	^ self hasRowFilter
		ifFalse: [ aCollection ]
		ifTrue: [ aCollection select: self rowFilter ]! !

!MAReportWidget methodsFor: 'testing' stamp: 'np 5/22/2009 14:08'!
hasMoreThanOnePage
	^self batchSize < self cache size! !

!MAReportWidget methodsFor: 'testing' stamp: 'np 5/22/2009 14:08'!
hasRowFilter
	^ self rowFilter notNil! !

!MAReportWidget methodsFor: 'initialization' stamp: 'np 5/22/2009 14:08'!
initialize
	super initialize.
	rows := columns := Array new.
	properties := Dictionary new.
	backtracked := Dictionary new! !

!MAReportWidget methodsFor: 'private-batch' stamp: 'np 5/22/2009 14:08'!
isOnFirstPage
	^ self batchPage = 1! !

!MAReportWidget methodsFor: 'private-batch' stamp: 'np 5/22/2009 14:08'!
isOnLastPage
	^ self batchPage = self batchMaxPages! !

!MAReportWidget methodsFor: 'testing' stamp: 'np 5/22/2009 14:08'!
isSorted
	^ self sortColumn notNil! !

!MAReportWidget methodsFor: 'columns' stamp: 'np 5/22/2009 14:08'!
moveDown: aColumn
	| index |
	index := self columns indexOf: aColumn ifAbsent: [ ^ self ].
	self columns swap: index with: (index = self size
		ifFalse:[ index + 1 ]
		ifTrue: [ 1 ])! !

!MAReportWidget methodsFor: 'columns' stamp: 'np 5/22/2009 14:08'!
moveUp: aColumn
	| index |
	index := self columns indexOf: aColumn ifAbsent: [ ^ self ].
	self columns swap: index with: (index = 1
		ifFalse:[ index - 1 ]
		ifTrue: [ self size ])! !

!MAReportWidget methodsFor: 'actions' stamp: 'np 5/22/2009 14:31'!
nextPage
	self isOnLastPage ifFalse: [
		self batchPage: self batchPage + 1.
		self markDirty]! !

!MAReportWidget methodsFor: 'actions' stamp: 'np 5/22/2009 14:31'!
previousPage
	self isOnFirstPage ifFalse: [
		self batchPage: self batchPage - 1.
		self markDirty]! !

!MAReportWidget methodsFor: 'actions' stamp: 'np 5/22/2009 14:31'!
refresh
	self cache: nil; batchPage: self defaultBatchPage.
	self columns do: [:each | each refresh].
	self markDirty! !

!MAReportWidget methodsFor: 'columns' stamp: 'np 5/22/2009 14:08'!
remove: aColumn
	columns := columns copyWithout: aColumn! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
rowFilter
	^ backtracked at: #rowFilter ifAbsent: [ self defaultRowFilter ]! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
rowFilter: aBlock
	backtracked at: #rowFilter put: aBlock.
	self refresh! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
rowPeriod
	^ properties at: #rowPeriod ifAbsent: [ self defaultRowPeriod ]! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
rowPeriod: aNumber
	properties at: #rowPeriod put: aNumber! !

!MAReportWidget methodsFor: 'private' stamp: 'np 5/22/2009 14:08'!
rowStyleForNumber: aNumber
	^ self rowStyles
		at: ((aNumber - 1 // self rowPeriod) \\ self rowStyles size) + 1
		ifAbsent: [ String new ]! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
rowStyles
	^ properties at: #rowStyles ifAbsent: [ self defaultRowStyles ]! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
rowStyles: aCollection
	properties at: #rowStyles put: aCollection! !

!MAReportWidget methodsFor: 'accessing' stamp: 'np 5/22/2009 14:08'!
rows
	"Return the rows of the receiver."

	^ rows! !

!MAReportWidget methodsFor: 'accessing' stamp: 'np 5/22/2009 14:08'!
rows: aCollection
	"Set the rows of the receiver."
	
	rows := aCollection.
	self refresh! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
showBatch
	^ properties at: #showBatch ifAbsent: [ self defaultShowBatch ]! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
showBatch: aBoolean
	properties at: #showBatch put: aBoolean! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
showBatchFirstLast
	^ properties at: #showBatchFirstLast ifAbsent: [ self defaultShowBatchFirstLast ]! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
showBatchFirstLast: aBoolean
	properties at: #showBatchFirstLast put: aBoolean! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
showBatchPages
	^ properties at: #showBatchPages ifAbsent: [ self defaultShowBatchPages ]! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
showBatchPages: aBoolean
	properties at: #showBatchPages put: aBoolean! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
showBatchPreviousNext
	^ properties at: #showBatchPreviousNext ifAbsent: [ self defaultShowBatchPreviousNext ]! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
showBatchPreviousNext: aBoolean
	properties at: #showBatchPreviousNext put: aBoolean! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
showBody
	^ properties at: #showBody ifAbsent: [ self defaultShowBody ]! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
showBody: aBoolean
	properties at: #showBody put: aBoolean! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
showCaption
	^ properties at: #showCaption ifAbsent: [ self defaultShowCaption ]! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
showCaption: aBoolean
	properties at: #showCaption put: aBoolean! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
showFooter
	^ properties at: #showFooter ifAbsent: [ self defaultShowFooter ]! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
showFooter: aBoolean
	properties at: #showFooter put: aBoolean! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
showHeader
	^ properties at: #showHeader ifAbsent: [ self defaultShowHeader ]! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
showHeader: aBoolean
	properties at: #showHeader put: aBoolean! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
showSummary
	^ properties at: #showSummary ifAbsent: [ self defaultShowSummary ]! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
showSummary: aBoolean
	properties at: #showSummary put: aBoolean! !

!MAReportWidget methodsFor: 'actions' stamp: 'np 5/22/2009 14:31'!
sort: aColumn
	aColumn = self sortColumn
		ifTrue: [
			self sortReversed
				ifFalse: [self sortReversed: true]
				ifTrue: [self sortColumn: nil; sortReversed: false]]
		ifFalse: [self sortColumn: aColumn; sortReversed: false].
	self refresh! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
sortColumn
	^ backtracked at: #sortColumn ifAbsent: [ self defaultSortColumn ]! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
sortColumn: aColumn
	backtracked at: #sortColumn put: aColumn! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
sortEnabled
	^ properties at: #sortEnabled ifAbsent: [ self defaultSortEnabled ]! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
sortEnabled: aBoolean
	properties at: #sortEnabled put: aBoolean! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
sortReversed
	^ backtracked at: #sortReversed ifAbsent: [ self defaultSortReversed ]! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
sortReversed: aBoolean
	backtracked at: #sortReversed put: aBoolean! !

!MAReportWidget methodsFor: 'private' stamp: 'np 5/22/2009 14:08'!
sortRows: aCollection
	^ self isSorted
		ifFalse: [ aCollection ]
		ifTrue: [ self sortColumn sortRows: aCollection ]! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
sorterStyles
	^ properties at: #sorterStyles ifAbsent: [ self defaultSorterStyles ]! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
sorterStyles: aCollection
	properties at: #sorterStyles put: aCollection! !

!MAReportWidget methodsFor: 'accessing-readonly' stamp: 'np 5/22/2009 14:08'!
states
	^ Array with: backtracked! !

!MAReportWidget methodsFor: 'building-table' stamp: 'np 10/1/2009 01:13'!
tableBatchContents
	^[:e |
		self hasMoreThanOnePage ifTrue: [| td |
			td := e tr td
				class: 'batch';
				colspan: self visibleColumns size;
				yourself.
			self showBatchFirstLast
				ifTrue: [ td build: self batchFirstContents].
			self showBatchPreviousNext
				ifTrue: [ td build: self batchPreviousContents].
			self showBatchPages
				ifTrue: [ td build: self batchItemsContents].
			self showBatchPreviousNext
				ifTrue: [ td build: self batchNextContents].
			self showBatchFirstLast
				ifTrue: [ td build: self batchLastContents]]]! !

!MAReportWidget methodsFor: 'building-table' stamp: 'np 10/1/2009 01:13'!
tableBodyContents
	^[:e |
		self visible isEmpty 
			ifTrue: [| tr | 
				tr := e tr
					class: 'empty';
					yourself. 
				tr td
					colspan: self visibleColumns size;
					text: self tableEmpty]
			ifFalse: [| tr |
				self visible keysAndValuesDo: [ :index :row | 
					tr := e tr
						class: (self rowStyleForNumber: index);
						yourself. 
					self visibleColumns do: [ :col | 
						tr build: (col 
							buildCell: row
							index: index)]]]]! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
tableCaption
	^ properties at: #tableCaption ifAbsent: [ self defaultTableCaption ]! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
tableCaption: aString
	properties at: #tableCaption put: aString! !

!MAReportWidget methodsFor: 'building-table' stamp: 'np 5/22/2009 14:28'!
tableCaptionContents
	^[:e |
		(e text tag: 'caption') add: self tableCaption]! !

!MAReportWidget methodsFor: 'building' stamp: 'np 10/1/2009 00:32'!
tableContents
	^[:e || thead tfoot tbody |
		self showCaption ifTrue: [
			e build: self tableCaptionContents].
		self showSummary ifTrue: [
			e build: self tableSummaryContents].
		thead := e thead.
		self showHeader ifTrue: [
			thead build: self tableHeadContents].
	((self showBatch
		and: [self hasMoreThanOnePage])
		or: [self showFooter]) ifTrue: [
			"we must not produce an empty tfoot element, this is not valid xhtml"
			tfoot := e tfoot.
			self showFooter ifTrue: [
				tfoot build: self tableFootContents].
			self showBatch ifTrue: [
				tfoot build: self tableBatchContents]].
	tbody := e tbody.
	self showBody ifTrue: [
		tbody build: self tableBodyContents]]! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
tableEmpty
	^ properties at: #tableEmpty ifAbsent: [ self defaultTableEmpty ]! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
tableEmpty: aString
	properties at: #tableEmpty put: aString! !

!MAReportWidget methodsFor: 'building-table' stamp: 'np 10/1/2009 00:34'!
tableFootContents
	^[:e || tr |
		tr := e tr.
		self visibleColumns do: [ :each |
			tr build: each buildFootCell]]! !

!MAReportWidget methodsFor: 'building-table' stamp: 'np 10/1/2009 00:34'!
tableHeadContents
	^[:e || tr |
		tr := e tr.
		self visibleColumns do: [ :each |
			tr build: each buildHeadCell]]! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
tableSummary
	^ properties at: #tableSummary ifAbsent: [ self defaultTableSummary ]! !

!MAReportWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 14:08'!
tableSummary: aString
	properties at: #tableSummary put: aString! !

!MAReportWidget methodsFor: 'building-table' stamp: 'np 6/3/2009 11:42'!
tableSummaryContents
	^[:e |
		(e text tag: 'summary') text: self tableSummary]! !

!MAReportWidget methodsFor: 'accessing-readonly' stamp: 'np 5/22/2009 14:08'!
visible
	^ self showBatch
		ifFalse: [ self cache ]
		ifTrue: [
			self cache
				copyFrom: self batchStartIndex
				to: self batchEndIndex ]! !

!MAReportWidget methodsFor: 'accessing-readonly' stamp: 'np 5/22/2009 14:08'!
visibleColumns
	^ self columns select: [ :each | each isVisible ]! !

!MAWidget class methodsFor: 'accessing' stamp: 'np 4/13/2009 15:36'!
description
	^MADescriptionBuilder for: self! !

!MAWidget class methodsFor: 'testing' stamp: 'np 4/13/2009 15:35'!
isAbstract
	^true! !

!MAWidget class methodsFor: 'instance creation' stamp: 'np 4/13/2009 15:36'!
new
	"Create a new instance of the receiving widget class and checks if it is not abstract."

	self isAbstract
		ifTrue: [self error: self name , ' is abstract.'].
	^super new! !

!MAWidget class methodsFor: 'reflection' stamp: 'np 4/13/2009 15:37'!
withAllConcreteClasses
	^Array streamContents: [:stream |
		self withAllConcreteClassesDo: [ :each |
			stream nextPut: each]]! !

!MAWidget class methodsFor: 'reflection' stamp: 'np 4/13/2009 15:37'!
withAllConcreteClassesDo: aBlock
	self withAllSubclassesDo: [:each |
		each isAbstract ifFalse: [
			aBlock value: each]]! !

!MAWidget methodsFor: 'accessing' stamp: 'np 4/19/2009 16:37'!
children
	^#()! !

!MAWidget methodsFor: 'testing' stamp: 'np 4/13/2009 15:35'!
isMultipart
	^self children contains: [:each | each isMultipart]! !

MAVisitor subclass: #MAWidgetBuilder
	instanceVariableNames: 'widget errors group element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Builders'!

MAWidgetBuilder subclass: #MATableBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Builders'!

!MATableBuilder methodsFor: 'building' stamp: 'np 4/19/2009 16:35'!
buildContainerFor: aDescription 
	^[:e |
		e
		class: (self classFor: aDescription);
		build: (super buildContainerFor: aDescription)]! !

!MATableBuilder methodsFor: 'building' stamp: 'np 10/1/2009 00:31'!
buildControlFor: aDescription
	^[:e |
		e td
			class: (self classFor: aDescription);
			build: (super buildControlFor: aDescription)]! !

!MATableBuilder methodsFor: 'building' stamp: 'np 10/1/2009 00:34'!
buildElementFor: aDescription
	^[:e |
		aDescription group = group
			ifFalse: [self buildGroupFor: aDescription].
		e tr 
			build: (self buildLabelFor: aDescription);
			build: (self buildControlFor: aDescription)]! !

!MATableBuilder methodsFor: 'building' stamp: 'np 10/1/2009 00:34'!
buildGroupFor: aDescription
	^[:e || trow |
		e build: (super buildGroupFor: aDescription).
		group isNil ifTrue: [^ self].
		trow := e tr class: 'group'; yourself.
		trow tableHeading 
			colSpan: 2;
			text: group]! !

!MATableBuilder methodsFor: 'building' stamp: 'np 10/1/2009 00:32'!
buildLabelFor: aDescription
	^[:e |
		e th
			title: aDescription comment;
			class: (self classFor: aDescription);
			build: (super buildLabelFor: aDescription)]! !

!MATableBuilder methodsFor: 'initialize-release' stamp: 'np 4/19/2009 16:35'!
setElement: anElement
	element := anElement table! !

!MAWidgetBuilder class methodsFor: 'instance creation' stamp: 'np 4/18/2009 16:05'!
widget: aWidget on: anElement
	^ self new widget: aWidget on: anElement! !

!MAWidgetBuilder methodsFor: 'building' stamp: 'np 4/24/2009 15:59'!
buildContainerFor: aDescription
	^[:e |
		self visitAll: (aDescription select: [:each |
		each isVisible
			and: [each widgetClass notNil]])]! !

!MAWidgetBuilder methodsFor: 'building' stamp: 'np 6/22/2009 15:27'!
buildControlFor: aDescription
	^[:e |
		e build: (self childAt: aDescription)]! !

!MAWidgetBuilder methodsFor: 'building' stamp: 'np 4/18/2009 18:38'!
buildElementFor: aDescription
	^[:e |
		aDescription group = group
			ifFalse: [self buildGroupFor: aDescription].
		e build: (self buildLabelFor: aDescription).
		e build: (self buildControlFor: aDescription)]! !

!MAWidgetBuilder methodsFor: 'building' stamp: 'np 4/18/2009 18:38'!
buildGroupFor: aDescription
	^[:e |
		group := aDescription group]! !

!MAWidgetBuilder methodsFor: 'building' stamp: 'np 5/25/2009 09:56'!
buildLabelFor: aDescription
	^[:e || label |
		aDescription hasLabel ifTrue: [
			label := e label.
			(self childAt: aDescription) hasLabelId
				ifTrue: [label for: (self childAt: aDescription) labelId].
			label text: aDescription label,':']]! !

!MAWidgetBuilder methodsFor: 'private' stamp: 'np 4/18/2009 15:29'!
childAt: aDescription
	^ widget childAt: aDescription! !

!MAWidgetBuilder methodsFor: 'private' stamp: 'np 4/18/2009 15:31'!
classFor: aDescription
	| classes |
	classes := OrderedCollection withAll: aDescription cssClasses.
	aDescription isReadonly
		ifTrue: [classes add: 'readonly'].
	aDescription isRequired
		ifTrue: [classes add: 'required'].
	(self hasError: aDescription)
		ifTrue: [classes add: 'error'].
	^ classes reduce: [ :a :b | a , ' ' , b ]! !

!MAWidgetBuilder methodsFor: 'testing' stamp: 'np 4/18/2009 15:32'!
hasError: aDescription
	| current |
	errors ifNotNil: [^errors includes: aDescription].
	errors := IdentitySet new.
	current := widget.
	[current notNil] whileTrue: [
		current isMagritteContainer ifTrue: [
			current errors do: [:each |
				errors add: (each tag isDescription
					ifTrue: [each tag]
					ifFalse: [current description])]].
		current := current parent].
	^ self hasError: aDescription! !

!MAWidgetBuilder methodsFor: 'initialization' stamp: 'np 4/18/2009 16:04'!
setElement: anElement
	element := anElement! !

!MAWidgetBuilder methodsFor: 'initialization' stamp: 'np 4/18/2009 16:14'!
setWidget: aWidget
	widget := aWidget! !

!MAWidgetBuilder methodsFor: 'visiting-description' stamp: 'np 4/18/2009 18:53'!
visitContainer: aDescription
	element build: (self buildContainerFor: aDescription)! !

!MAWidgetBuilder methodsFor: 'visiting-description' stamp: 'np 4/18/2009 18:53'!
visitElementDescription: aDescription
	element build: (self buildElementFor: aDescription)! !

!MAWidgetBuilder methodsFor: 'visiting' stamp: 'np 4/18/2009 18:52'!
widget: aWidget on: anElement
	self setWidget: aWidget; setElement: anElement.
	self visit: aWidget description! !

!MAFileDescription class methodsFor: '*Iliad-More-Magritte' stamp: 'np 4/18/2009 18:12'!
defaultWidgetClasses
	^Array with: MAFileUploadWidget! !

ILDecorator subclass: #MAWidgetDecorator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Decorators'!

MAWidgetDecorator subclass: #MAContainerDecorator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Decorators'!

!MAContainerDecorator methodsFor: 'accessing' stamp: 'np 4/17/2009 20:47'!
buttons
	"Answer a collection of associations. The key is either a symbol that will be performed on the decorated widget or a one-argument block that will be executed with the widget as argument. The value is the button label."
	
	self subclassResponsibility! !

!MAContainerDecorator methodsFor: 'building' stamp: 'np 10/1/2009 00:55'!
buttonsContents
	^[:e || div |
		div := e div 
			class: 'buttons';
			yourself.
		self buttons do: [:each |
			div button
				accesskey: each value first;
				action: [self execute: each key];
				text: each value]]! !

!MAContainerDecorator methodsFor: 'building' stamp: 'np 4/20/2009 17:13'!
contents
	^[:e |
		e form
			class: 'magritte';
			multipart: self isMultipart;
			build: self decoratee contents; 
			build: self buttonsContents]! !

!MAContainerDecorator methodsFor: 'accessing' stamp: 'np 4/17/2009 20:47'!
default
	^self buttons first key! !

!MAContainerDecorator methodsFor: 'actions' stamp: 'np 4/19/2009 18:43'!
execute: anObject
	anObject isSymbol
		ifFalse: [anObject value: self widget]
		ifTrue: [self widget perform: anObject]! !

MAContainerDecorator subclass: #MAFormDecorator
	instanceVariableNames: 'buttons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Decorators'!

!MAFormDecorator commentStamp: 'np 4/17/2009 20:54' prior: 0!
I surround the decoratee widget with a XHTML form element and build the form buttons.!

!MAFormDecorator class methodsFor: 'instance creation' stamp: 'np 4/17/2009 20:53'!
buttons: aCollection
	^ self new
		addButtons: aCollection;
		yourself! !

!MAFormDecorator methodsFor: 'actions' stamp: 'np 4/5/2010 17:49'!
addButton: aSymbol
	self addButton: aSymbol label: aSymbol greaseString! !

!MAFormDecorator methodsFor: 'actions' stamp: 'np 4/17/2009 20:53'!
addButton: aSymbolOrOneArgumentBlock label: aString
	self buttons add: aSymbolOrOneArgumentBlock -> aString! !

!MAFormDecorator methodsFor: 'actions' stamp: 'np 4/17/2009 20:55'!
addButtons: aCollection
	aCollection do: [:each |
		each isVariableBinding
			ifFalse: [self addButton: each]
			ifTrue: [self addButton: each key label: each value]]! !

!MAFormDecorator methodsFor: 'accessing' stamp: 'np 4/17/2009 20:53'!
buttons
	^ buttons! !

!MAFormDecorator methodsFor: 'accessing' stamp: 'np 4/17/2009 20:53'!
buttons: aCollection
	buttons := aCollection! !

!MAFormDecorator methodsFor: 'initialization' stamp: 'np 4/17/2009 20:53'!
initialize
	super initialize.
	self buttons: OrderedCollection new! !

MAContainerDecorator subclass: #MASwitchDecorator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Decorators'!

!MASwitchDecorator methodsFor: 'accessing' stamp: 'np 4/19/2009 18:40'!
buttons
	^self widget isReadonly
		ifTrue: [Array with: #edit -> 'Edit']
		ifFalse: [Array with: #save -> 'Save' with: #cancel -> 'Cancel']! !

!MASwitchDecorator methodsFor: 'decorations' stamp: 'np 4/17/2009 20:58'!
handleAnswer: anAnswer
	self widget readonly: true.
	super handleAnswer: anAnswer! !

MAWidgetDecorator subclass: #MAValidationDecorator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Decorators'!

!MAValidationDecorator methodsFor: 'building' stamp: 'np 4/17/2009 21:01'!
contents
	^[:e |
		self errors isEmpty ifFalse: [
			e build: self errorsContents].
		e build: self decoratee contents]! !

!MAValidationDecorator methodsFor: 'accessing' stamp: 'np 4/17/2009 20:59'!
errors
	^self widget errors! !

!MAValidationDecorator methodsFor: 'building' stamp: 'np 4/5/2010 17:47'!
errorsContents
	^[:e || list |
		list := e ul
			class: 'errors';
			yourself.
		self errors do: [:each |
			list li text: each greaseString]]! !

!MAWidgetDecorator methodsFor: 'testing' stamp: 'np 4/19/2009 17:02'!
isMultipart
	^self widget isMultipart ! !

!MADateDescription class methodsFor: '*Iliad-More-Magritte' stamp: 'np 4/21/2009 15:20'!
defaultComponentClasses
	^ Array with: MADateSelectorWidget! !

!MADateDescription class methodsFor: '*Iliad-More-Magritte' stamp: 'np 4/21/2009 15:29'!
defaultWidgetClasses
	^ Array with: MADateSelectorWidget! !

!MASingleOptionDescription class methodsFor: '*Iliad-More-Magritte' stamp: 'np 4/18/2009 18:16'!
defaultWidgetClasses
	^ Array with: MASelectListWidget! !

Object subclass: #MAColumnWidget
	instanceVariableNames: 'report properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Report'!

MAColumnWidget subclass: #MAActionColumnWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Report'!

!MAActionColumnWidget methodsFor: 'building' stamp: 'np 5/22/2009 13:45'!
buildCellContent: anObject
	^[:e | self useLinks
		ifTrue: [e build: (self buildCellLinkContent: anObject)]
		ifFalse: [e build: (self buildCellFormContent: anObject)]]! !

!MAActionColumnWidget methodsFor: 'building' stamp: 'np 5/22/2009 13:46'!
buildCellFormContent: anObject
	self subclassResponsibility! !

!MAActionColumnWidget methodsFor: 'building' stamp: 'np 5/22/2009 13:46'!
buildCellLinkContent: anObject
	self subclassResponsibility! !

!MAActionColumnWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 13:44'!
defaultTitle
	^ String new! !

!MAActionColumnWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 13:44'!
defaultUseLinks
	^ true! !

!MAActionColumnWidget methodsFor: 'accessing' stamp: 'np 5/22/2009 13:44'!
useLinks
	^ self propertyAt: #useLinks ifAbsent: [ self defaultUseLinks ]! !

!MAActionColumnWidget methodsFor: 'accessing' stamp: 'np 5/22/2009 13:44'!
useLinks: aBoolean
	self propertyAt: #useLinks put: aBoolean! !

MAActionColumnWidget subclass: #MACommandColumnWidget
	instanceVariableNames: 'commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Report'!

!MACommandColumnWidget methodsFor: 'actions' stamp: 'np 9/20/2009 19:43'!
addCommand: aBlock text: aString
	self addCommand: aBlock text: aString hash: [:val | '']! !

!MACommandColumnWidget methodsFor: 'actions' stamp: 'np 9/20/2009 19:42'!
addCommand: aBlock text: aString hash: anotherBlock
	self commands add: (aBlock -> anotherBlock) -> aString! !

!MACommandColumnWidget methodsFor: 'actions' stamp: 'np 5/22/2009 13:47'!
addCommandOn: anObject selector: aSelector
	self addCommandOn: anObject selector: aSelector text: aSelector allButLast asCapitalizedPhrase! !

!MACommandColumnWidget methodsFor: 'actions' stamp: 'np 5/22/2009 13:47'!
addCommandOn: anObject selector: aSelector text: aString
	self addCommand: (MessageSend receiver: anObject selector: aSelector) text: aString! !

!MACommandColumnWidget methodsFor: 'building' stamp: 'np 9/20/2009 19:43'!
buildCellFormContent: anObject
	^[:e | 
		self commands 
			do: [:each |
				e submitButton
					action: [each key key value: anObject]
					hash: [each key value value: anObject];
					text: each value]
			separatedBy: [e space]]! !

!MACommandColumnWidget methodsFor: 'building' stamp: 'np 10/1/2009 00:06'!
buildCellLinkContent: anObject
	^[:e | 
		self commands
			do: [:each |
				e a
					action: [each key key value: anObject]
					hash: (each key value value: anObject);
					text: each value]
			separatedBy: [e space]]! !

!MACommandColumnWidget methodsFor: 'accessing' stamp: 'np 5/22/2009 13:47'!
commands
	^ commands! !

!MACommandColumnWidget methodsFor: 'accessing' stamp: 'np 5/22/2009 13:47'!
commands: aCollection
	commands := aCollection! !

!MACommandColumnWidget methodsFor: 'initialization' stamp: 'np 5/22/2009 13:47'!
initialize
	super initialize.
	self commands: OrderedCollection new! !

MACommandColumnWidget subclass: #MAIndexedCommandColumnWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Report'!

!MAIndexedCommandColumnWidget methodsFor: 'building' stamp: 'np 10/1/2009 00:06'!
buildCellContent: anObject index: anInteger
	^[:e | 
		self commands
			do: [:each |
				e a
					action: [ each key valueWithArguments: (Array
						with: anObject
						with: anInteger)];
					text: each value]
			separatedBy: [e space]]! !

!MAIndexedCommandColumnWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 13:50'!
defaultFormat
	^ MessageSend receiver: self selector: #renderCellContent:on:index:! !

MAActionColumnWidget subclass: #MASelectionColumnWidget
	instanceVariableNames: 'selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Report'!

MASelectionColumnWidget subclass: #MACheckboxColumnWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Report'!

!MACheckboxColumnWidget methodsFor: 'building' stamp: 'np 5/22/2009 13:58'!
buildCellFormContent: anObject
	^[:e | 
		e checkbox
			checked: (self isSelected: anObject);
			action: [:value | self selectRow: anObject value: value]]! !

!MACheckboxColumnWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 13:56'!
defaultSelection
	^ Set new! !

!MACheckboxColumnWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 13:56'!
defaultStringDeselected
	^ self webdings: 'c'! !

!MACheckboxColumnWidget methodsFor: 'accessing-defaults' stamp: 'np 9/21/2009 10:58'!
defaultStringSelected
	^ self webdings: 'g'! !

!MACheckboxColumnWidget methodsFor: 'actions' stamp: 'np 5/22/2009 13:58'!
deselectRow: anObject
	self selection remove: anObject ifAbsent: nil.
	self report markDirty! !

!MACheckboxColumnWidget methodsFor: 'testing' stamp: 'np 5/22/2009 13:56'!
isSelected: anObject
	^ self selection includes: anObject! !

!MACheckboxColumnWidget methodsFor: 'actions' stamp: 'np 5/22/2009 13:58'!
selectRow: anObject
	self selection add: anObject.
	self report markDirty! !

!MASelectionColumnWidget methodsFor: 'building' stamp: 'np 10/1/2009 00:07'!
buildCellLinkContent: anObject
	| selected |
	selected := self isSelected: anObject.
	^[:e |
		e a
			class: (selected isNil ifFalse: ['selected']);
			action: [self selectRow: anObject value: selected not];
			build: (selected
				ifTrue: [self stringSelected]
				ifFalse: [self stringDeselected])]! !

!MASelectionColumnWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 13:52'!
defaultSelection
	self subclassResponsibility! !

!MASelectionColumnWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 13:52'!
defaultStringDeselected
	self subclassResponsibility! !

!MASelectionColumnWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 13:52'!
defaultStringSelected
	self subclassResponsibility! !

!MASelectionColumnWidget methodsFor: 'actions' stamp: 'np 5/22/2009 13:52'!
deselectRow: anObject
	self subclassResponsibility! !

!MASelectionColumnWidget methodsFor: 'testing' stamp: 'np 5/22/2009 13:52'!
isSelected: anObject
	self subclassResponsibility! !

!MASelectionColumnWidget methodsFor: 'actions' stamp: 'np 5/22/2009 13:52'!
refresh
	super refresh.
	self selection: self defaultSelection! !

!MASelectionColumnWidget methodsFor: 'actions' stamp: 'np 5/22/2009 13:52'!
selectRow: anObject
	self subclassResponsibility! !

!MASelectionColumnWidget methodsFor: 'actions' stamp: 'np 5/22/2009 13:52'!
selectRow: anObject value: aBoolean
	aBoolean
		ifTrue: [ self selectRow: anObject ]
		ifFalse: [ self deselectRow: anObject ]! !

!MASelectionColumnWidget methodsFor: 'accessing' stamp: 'np 5/22/2009 13:52'!
selection
	selection isNil
		ifTrue: [ self selection: self defaultSelection ].
	^ selection! !

!MASelectionColumnWidget methodsFor: 'accessing' stamp: 'np 5/22/2009 13:52'!
selection: anObject
	selection := anObject! !

!MASelectionColumnWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 13:52'!
stringDeselected
	^ self propertyAt: #stringDeselected ifAbsent: [ self defaultStringDeselected ]! !

!MASelectionColumnWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 13:52'!
stringDeselected: aString
	^ self propertyAt: #stringDeselected put: aString! !

!MASelectionColumnWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 13:52'!
stringSelected
	^ self propertyAt: #stringSelected ifAbsent: [ self defaultStringSelected ]! !

!MASelectionColumnWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 13:52'!
stringSelected: aString
	^ self propertyAt: #stringSelected put: aString! !

!MASelectionColumnWidget methodsFor: 'private' stamp: 'np 9/21/2009 10:49'!
webdings: aString
	^[:e | e span 
			style: 'font-family: Webdings';
			text: aString]! !

!MAColumnWidget class methodsFor: 'accessing-description' stamp: 'np 5/22/2009 13:31'!
descriptionComment
	^ MAStringDescription new
		accessor: #comment;
		label: 'Comment';
		priority: 200;
		yourself! !

!MAColumnWidget class methodsFor: 'accessing-description' stamp: 'np 5/22/2009 13:31'!
descriptionTitle
	^ MAStringDescription new
		accessor: #title;
		label: 'Title';
		priority: 100;
		yourself! !

!MAColumnWidget class methodsFor: 'instance creation' stamp: 'np 5/22/2009 13:31'!
new
	^ self basicNew initialize! !

!MAColumnWidget methodsFor: 'building' stamp: 'np 10/1/2009 00:30'!
buildCell: anObject index: anInteger
	^[:e |
		e td build: (self format 
			valueWithArguments: ((Array with: anObject with: anInteger)
			first: self format selector numArgs))]! !

!MAColumnWidget methodsFor: 'building' stamp: 'np 6/3/2009 11:37'!
buildCellContent: anObject
	^[:e |
		e text: (self valueFor: anObject)]! !

!MAColumnWidget methodsFor: 'building' stamp: 'np 10/1/2009 00:30'!
buildFootCell
	^[:e |
		e td build: (self buildFootContent)]! !

!MAColumnWidget methodsFor: 'building' stamp: 'np 6/3/2009 11:38'!
buildFootContent
	^[:e | 
		self footer isNil ifFalse: [
			e build: self footer]]! !

!MAColumnWidget methodsFor: 'building' stamp: 'np 10/1/2009 00:32'!
buildHeadCell
	^[:e || th |
		th := e th
			class: self sorterStyle;
			title: (self comment ifNil: ['']);
			yourself.
		self isSortable
			ifFalse: [th build: self buildHeadContent]
			ifTrue: [
				th a
					action: [self report sort: self];
					build: self buildHeadContent]]! !

!MAColumnWidget methodsFor: 'building' stamp: 'np 6/3/2009 11:38'!
buildHeadContent
	^[:e | 
		e text: self title]! !

!MAColumnWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 13:31'!
cascade
	^ self propertyAt: #cascade ifAbsent: [ self defaultCascade ]! !

!MAColumnWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 13:31'!
cascade: anArray
	self propertyAt: #cascade put: anArray! !

!MAColumnWidget methodsFor: 'accessing' stamp: 'np 5/22/2009 13:31'!
column
	^ self report cache collect: [ :each | self valueFor: each ]! !

!MAColumnWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 13:31'!
comment
	^ self propertyAt: #comment ifAbsent: [ self defaultComment ]! !

!MAColumnWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 13:31'!
comment: aString
	self propertyAt: #comment put: aString! !

!MAColumnWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 13:31'!
defaultCascade
	^ #( yourself )! !

!MAColumnWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 13:31'!
defaultComment
	^ nil! !

!MAColumnWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 13:31'!
defaultFooter
	^ nil! !

!MAColumnWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 13:35'!
defaultFormat
	^ MessageSend receiver: self selector: #buildCellContent:! !

!MAColumnWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 13:31'!
defaultSorter
	^[ :a :b |
		| x y |
		(x := self valueFor: a) isNil
			or: [ (y := self valueFor: b) notNil
				and: [ x <= y ] ] ]! !

!MAColumnWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 13:31'!
defaultTitle
	^ self cascade first asCapitalizedPhrase! !

!MAColumnWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 13:31'!
defaultVisible
	^ true! !

!MAColumnWidget methodsFor: 'exporting' stamp: 'np 4/5/2010 17:49'!
exportContent: anObject index: aNumber on: aStream
	aStream nextPutAll: (anObject greaseString collect: [ :each |
		each isSeparator
			ifTrue: [ Character space ]
			ifFalse: [ each ] ])! !

!MAColumnWidget methodsFor: 'exporting' stamp: 'np 5/22/2009 13:31'!
exportHeadOn: aStream
	self title isNil
		ifFalse: [ aStream nextPutAll: self title ]! !

!MAColumnWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 13:31'!
footer
	^ self propertyAt: #footer ifAbsent: [ self defaultFooter ]! !

!MAColumnWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 13:31'!
footer: aBlock
	self propertyAt: #footer put: aBlock! !

!MAColumnWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 13:31'!
format
	^ self propertyAt: #format ifAbsent: [ self defaultFormat ]! !

!MAColumnWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 13:31'!
format: aBlock
	self propertyAt: #format put: aBlock! !

!MAColumnWidget methodsFor: 'accessing' stamp: 'np 5/22/2009 13:31'!
index
	^ self report columns indexOf: self! !

!MAColumnWidget methodsFor: 'initialization' stamp: 'np 5/22/2009 13:31'!
initialize
	properties := Dictionary new! !

!MAColumnWidget methodsFor: 'testing' stamp: 'np 5/22/2009 13:31'!
isReversed
	^ self report sortReversed! !

!MAColumnWidget methodsFor: 'testing' stamp: 'np 5/22/2009 13:31'!
isSortable
	^ self report sortEnabled
		and: [ self sorter notNil ]! !

!MAColumnWidget methodsFor: 'testing' stamp: 'np 5/22/2009 13:31'!
isSorted
	^ self report sortColumn = self! !

!MAColumnWidget methodsFor: 'testing' stamp: 'np 5/22/2009 13:31'!
isVisible
	^ self visible! !

!MAColumnWidget methodsFor: 'accessing-properties' stamp: 'np 5/22/2009 13:31'!
properties
	^ properties! !

!MAColumnWidget methodsFor: 'accessing-properties' stamp: 'np 5/22/2009 13:31'!
propertyAt: aSymbol
	^ self properties at: aSymbol! !

!MAColumnWidget methodsFor: 'accessing-properties' stamp: 'np 5/22/2009 13:31'!
propertyAt: aSymbol ifAbsent: aBlock
	^ self properties at: aSymbol ifAbsent: aBlock! !

!MAColumnWidget methodsFor: 'accessing-properties' stamp: 'np 5/22/2009 13:31'!
propertyAt: aSymbol ifAbsentPut: aBlock
	^ self properties at: aSymbol ifAbsentPut: aBlock! !

!MAColumnWidget methodsFor: 'accessing-properties' stamp: 'np 5/22/2009 13:31'!
propertyAt: aSymbol put: anObject
	^ self properties at: aSymbol put: anObject! !

!MAColumnWidget methodsFor: 'actions' stamp: 'np 5/22/2009 13:58'!
refresh
	self report markDirty! !

!MAColumnWidget methodsFor: 'accessing' stamp: 'np 5/22/2009 13:31'!
report
	^ report! !

!MAColumnWidget methodsFor: 'actions' stamp: 'np 5/22/2009 14:00'!
selector: aSymbol
	self cascade: (Array with: aSymbol)! !

!MAColumnWidget methodsFor: 'initialization' stamp: 'np 5/22/2009 13:31'!
setReport: aReport
	report := aReport! !

!MAColumnWidget methodsFor: 'actions' stamp: 'np 5/22/2009 14:00'!
sortRows: aCollection
	| result |
	result := SortedCollection new: aCollection size.
	result
		sortBlock: self sorter;
		addAll: aCollection.
	^self isReversed
		ifFalse: [result]
		ifTrue: [result reversed]! !

!MAColumnWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 13:31'!
sorter
	^ self propertyAt: #sorter ifAbsent: [ self defaultSorter ]! !

!MAColumnWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 13:31'!
sorter: aBlock
	self propertyAt: #sorter put: aBlock! !

!MAColumnWidget methodsFor: 'accessing' stamp: 'np 5/22/2009 13:31'!
sorterStyle
	^ self isSorted
		ifTrue: [
			self isReversed
				ifTrue: [ self report sorterStyles first ]
				ifFalse: [ self report sorterStyles second ] ]
		ifFalse: [ String new ]! !

!MAColumnWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 13:31'!
title
	^ self propertyAt: #title ifAbsent: [ self defaultTitle ]! !

!MAColumnWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 13:31'!
title: aString
	self propertyAt: #title put: aString! !

!MAColumnWidget methodsFor: 'actions' stamp: 'np 5/22/2009 13:59'!
valueFor: aRow
	^self cascade
		inject: aRow
		into: [:result :each | result perform: each]! !

!MAColumnWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 13:31'!
visible
	^ self propertyAt: #visible ifAbsent: [ self defaultVisible ]! !

!MAColumnWidget methodsFor: 'accessing-settings' stamp: 'np 5/22/2009 13:31'!
visible: aBoolean
	self propertyAt: #visible put: aBoolean! !

MAColumnWidget subclass: #MAContentsColumnWidget
	instanceVariableNames: 'contentsBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Report'!

!MAContentsColumnWidget methodsFor: 'building' stamp: 'np 9/20/2009 20:35'!
buildCellContent: anObject
	^[:e |
		self contentsBlock value: e value: anObject]! !

!MAContentsColumnWidget methodsFor: 'accessing' stamp: 'np 9/20/2009 20:28'!
contentsBlock
	^contentsBlock! !

!MAContentsColumnWidget methodsFor: 'accessing' stamp: 'np 9/20/2009 20:28'!
contentsBlock: aBlock
	contentsBlock := aBlock! !

!MAContentsColumnWidget methodsFor: 'accessing-defaults' stamp: 'np 9/20/2009 20:49'!
defaultTitle
	^ String new! !

MAColumnWidget subclass: #MADescribedColumnWidget
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Report'!

!MADescribedColumnWidget methodsFor: 'building' stamp: 'np 6/3/2009 11:39'!
buildCellContent: anObject
	^[:e |
		e text: (self description toString: (self valueFor: anObject))]! !

!MADescribedColumnWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 14:04'!
defaultCascade
	self shouldNotImplement! !

!MADescribedColumnWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 14:04'!
defaultSorter
	^ self description isSortable ifTrue: [ super defaultSorter ]! !

!MADescribedColumnWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 14:04'!
defaultTitle
	^ self description label! !

!MADescribedColumnWidget methodsFor: 'accessing-defaults' stamp: 'np 5/22/2009 14:04'!
defaultVisible
	^ self description isVisible! !

!MADescribedColumnWidget methodsFor: 'accessing' stamp: 'np 5/22/2009 14:04'!
description
	^ description! !

!MADescribedColumnWidget methodsFor: 'exporting' stamp: 'np 5/22/2009 14:04'!
exportContent: anObject index: aNumber on: aStream
	super exportContent: (self description toString: anObject) index: aNumber on: aStream! !

!MADescribedColumnWidget methodsFor: 'initialization' stamp: 'np 5/22/2009 14:04'!
setDescription: aDescription
	description := aDescription! !

!MADescribedColumnWidget methodsFor: 'actions' stamp: 'np 5/22/2009 14:04'!
valueFor: aRow
	^ (aRow readUsing: self description)
		ifNil: [ self description default ]! !

MADescribedColumnWidget subclass: #MADescribedScalarColumnWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Report'!

!MADescribedScalarColumnWidget methodsFor: 'building' stamp: 'np 5/22/2009 14:06'!
buildCellContent: anObject
	^[:e |
		e add: (self description reference toString: (self valueFor: anObject))]! !

!MADescribedScalarColumnWidget methodsFor: 'actions' stamp: 'np 5/22/2009 14:06'!
valueFor: aRow
	^aRow! !

MADescribedColumnWidget subclass: #MAToggleColumnWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Magritte-Report'!

!MAToggleColumnWidget methodsFor: 'building' stamp: 'np 10/1/2009 00:07'!
buildCellContent: anObject
	| value |
	value := self valueFor: anObject.
	^[:e |
		e a
			action: [anObject write: value not using: self description];
			text: (self description toString: value)]! !

!Object methodsFor: '*Iliad-More-Magritte' stamp: 'np 4/18/2009 17:55'!
asWidget
	^ self description asWidgetOn: self! !

!MATimeDescription class methodsFor: '*Iliad-More-Magritte' stamp: 'np 4/21/2009 15:35'!
defaultWidgetClasses
	^ Array with: MATimeSelectorWidget! !

!MATimeStampDescription class methodsFor: '*Iliad-More-Magritte' stamp: 'np 4/21/2009 15:42'!
defaultWidgetClasses
	^ Array with: MATimeStampSelectorWidget ! !

!MABooleanDescription class methodsFor: '*Iliad-More-Magritte' stamp: 'np 4/18/2009 18:10'!
defaultWidgetClasses
	^Array with: MACheckboxWidget with: MASelectListWidget ! !

!MAToManyRelationDescription class methodsFor: '*Iliad-More-Magritte' stamp: 'np 7/12/2009 19:51'!
defaultWidgetClasses
	^ Array with: MAOneToManyWidget! !

!MAMultipleOptionDescription class methodsFor: '*Iliad-More-Magritte' stamp: 'np 4/18/2009 18:14'!
defaultWidgetClasses
	^Array with: MAMultiselectListWidget with: MACheckboxGroupWidget ! !

!MAMemoDescription class methodsFor: '*Iliad-More-Magritte' stamp: 'np 4/18/2009 18:12'!
defaultWidgetClasses
	^ Array with: MATextAreaWidget! !

!MAContainer class methodsFor: '*Iliad-More-Magritte' stamp: 'np 4/18/2009 18:31'!
defaultWidgetBuilder
	^MATableBuilder! !

!MAContainer class methodsFor: '*Iliad-More-Magritte' stamp: 'np 4/18/2009 18:22'!
defaultWidgetClasses
	^Array with: MAContainerWidget! !

!MAContainer methodsFor: '*Iliad-More-Magritte' stamp: 'np 4/18/2009 17:56'!
asWidgetOn: anObject
	^self widgetClass
		memento: (anObject mementoClass
			model: anObject
			description: self)! !

!MAContainer methodsFor: '*Iliad-More-Magritte' stamp: 'np 4/18/2009 18:29'!
widgetBuilder
	^self propertyAt: #widgetBuilder ifAbsent: [self class defaultWidgetBuilder]! !

!MAContainer methodsFor: '*Iliad-More-Magritte' stamp: 'np 4/18/2009 18:29'!
widgetBuilder: aClass
	self propertyAt: #widgetBuilder put: aClass! !

!MAToOneRelationDescription class methodsFor: '*Iliad-More-Magritte' stamp: 'np 4/20/2009 16:35'!
defaultWidgetClasses
	^ Array with: MAExternalEditorWidget with: MAInternalEditorWidget! !

!MADescription class methodsFor: '*Iliad-More-Magritte' stamp: 'np 4/18/2009 18:05'!
defaultCssClasses
	^OrderedCollection new! !

!MADescription class methodsFor: '*Iliad-More-Magritte' stamp: 'np 5/22/2009 14:41'!
defaultReportColumnWidgetClass
	^self defaultReportColumnWidgetClasses notEmpty
		ifTrue: [self defaultReportColumnWidgetClasses first]! !

!MADescription class methodsFor: '*Iliad-More-Magritte' stamp: 'np 5/22/2009 14:41'!
defaultReportColumnWidgetClasses
	^Array with: MADescribedColumnWidget! !

!MADescription class methodsFor: '*Iliad-More-Magritte' stamp: 'np 4/18/2009 18:01'!
defaultWidgetClass
	^self defaultWidgetClasses notEmpty
		ifTrue: [self defaultWidgetClasses first]
		ifFalse: [MAUndefinedWidget]! !

!MADescription class methodsFor: '*Iliad-More-Magritte' stamp: 'np 4/18/2009 18:03'!
defaultWidgetClasses
	^Array with: MAUndefinedWidget! !

!MADescription class methodsFor: '*Iliad-More-Magritte' stamp: 'np 5/22/2009 14:43'!
descriptionReportColumnWidgetClass
	^ MASingleOptionDescription new
		accessor: #reportColumnWidgetClass;
		label: 'Report Column Class';
		priority: 1010;
		reference: MAClassDescription new;
		options: self defaultReportColumnWidgetClasses;
		default: self defaultReportColumnWidgetClass;
		yourself! !

!MADescription class methodsFor: '*Iliad-More-Magritte' stamp: 'np 4/18/2009 18:02'!
descriptionWidgetClass
	^MASingleOptionDescription new
		accessor: #widgetClass;
		label: 'Component Class';
		reference: MAClassDescription new;
		options: self defaultWidgetClasses;
		default: self defaultWidgetClass;
		priority: 1000;
		yourself! !

!MADescription methodsFor: '*Iliad-More-Magritte' stamp: 'np 4/24/2009 14:24'!
cssClass: aString
	(self propertyAt: #cssClasses ifAbsentPut: [ self class defaultCssClasses ])
		add: aString! !

!MADescription methodsFor: '*Iliad-More-Magritte' stamp: 'np 4/24/2009 14:24'!
cssClasses
	^ self propertyAt: #cssClasses ifAbsent: [ self class defaultCssClasses ]! !

!MADescription methodsFor: '*Iliad-More-Magritte' stamp: 'np 4/24/2009 14:24'!
cssClasses: aCollection
	self propertyAt: #cssClasses put: aCollection! !

!MADescription methodsFor: '*Iliad-More-Magritte' stamp: 'np 5/22/2009 14:44'!
reportColumnWidgetClass
	^ self propertyAt: #reportColumnWidgetClass ifAbsent: [ self class defaultReportColumnWidgetClass ]! !

!MADescription methodsFor: '*Iliad-More-Magritte' stamp: 'np 5/22/2009 14:44'!
reportColumnWidgetClass: aClass
	^ self propertyAt: #reportColumnWidgetClass put: aClass! !

!MADescription methodsFor: '*Iliad-More-Magritte' stamp: 'np 4/18/2009 17:58'!
widgetClass
	^self propertyAt: #widgetClass ifAbsent: [self class defaultWidgetClass]! !

!MADescription methodsFor: '*Iliad-More-Magritte' stamp: 'np 4/18/2009 17:58'!
widgetClass: aClass
	^self propertyAt: #widgetClass put: aClass! !

!MAElementDescription class methodsFor: '*Iliad-More-Magritte' stamp: 'np 4/18/2009 18:25'!
defaultWidgetClasses
	^Array with: MATextInputWidget! !

!MAPasswordDescription class methodsFor: '*Iliad-More-Magritte' stamp: 'np 4/18/2009 18:15'!
defaultWidgetClasses
	^Array with: MATextPasswordWidget with: MAVerifiedPasswordWidget with: MATextInputWidget! !
